#!/bin/csh

# @(#)gendoc.sh	1.14 95/04/20 Patrick Chan
# This script pulls together documentation from all over the place 
# and places it all here.  (Eventually this script should be outside
# of the workspace or all the docs should be added to the workspace).

# This script generates a file called ListOfBooks which lists
# all available books for the java search window.  This list
# also specifies the name of the directory in which to store
# the html files and their index.

cat >ListOfBooks <<ENDOFINPUT
All Books
indexOfAllBooks
JAVA Language Specification
javaspec
JAVA Class Libraries
api
Manpages
man
Writing and Using HotJava Applets
appguide
JAVA Virtual Machine Specification
vmspec
Implementing Native Methods
rpi
ENDOFINPUT

# get rpi
set book=rpi
rm -rf $book
mkdir $book
cp /usr/green/TechPubs/Java1.0/RPI/HTML/* $book
chmod +w $book/*.html
touch $book/,$$
rm -f $book/,*

# get JAVA spec
set book=javaspec
rm -rf $book
mkdir $book
cp /usr/green/TechPubs/Java1.0/Spec/HTML/* $book
chmod +w $book/*.html
touch $book/,$$
rm -f $book/,*

# get JAVA virtual machine spec
set book=vmspec
rm -rf $book
mkdir $book
cp /usr/green/TechPubs/Java1.0/VMSpec/HTML/* $book
chmod +w $book/*.html
touch $book/,$$
rm -f $book/,*

# make all indexes
set book=indexOfAllBooks
if (! -e $book) mkdir $book
