/*-
 * Copyright (c) 1994 by FirstPerson, Inc.
 * All rights reserved.
 *
 * @(#)Prof.java	1.8 95/01/31 April 1994
 */

// I know that this code sucks. It needs to be rewritten
// using InputStreams and a tokenizer. I'm too lazy...

package java.prof;

import java.util.Hashtable;
import java.util.Enumeration;
import java.io.FileInputStream;

class TypeSignature {
    //
    // Character constants used in type signatures
    //
    static final char ERROR	= 'E';
    static final char VOID	= 'V';
    static final char BOOLEAN	= 'Z';
    static final char BYTE	= 'B';
    static final char CHAR	= 'C';
    static final char SHORT	= 'S';
    static final char INT	= 'I';
    static final char FLOAT	= 'F';
    static final char LONG	= 'J';
    static final char DOUBLE	= 'D';

    static final char ARRAY		= '[';
    static final char METHOD		= '(';
    static final char METHODEND	= ')';
    static final char OBJECT		= 'L';
    static final char OBJECTEND	= ';';

    /**
     * Convert an Java TypeSignature to a readable String
     */
    public static String toString(String sig, String id, boolean abbrev, boolean ret) {
	String s;
	
	switch (sig.charAt(0)) {
	  case BOOLEAN:	s = "boolean"; 	break;
	  case BYTE:    s = "byte"; 	break;
	  case CHAR:	s = "char"; 	break;
	  case SHORT:   s = "short";	break;
	  case INT:	s = "int";	break;
	  case LONG:	s = "long";	break;
	  case FLOAT:	s = "float";	break;
	  case DOUBLE:	s = "double";	break;

	  case ARRAY:
	    s = TypeSignature.toString(sig.substring(1), id, abbrev, ret);
	    return s + "[]";

	  case OBJECT:
	    s = sig.substring(1, sig.length() - 1);
	    return abbrev ? s.substring(s.lastIndexOf('/') + 1) : s.replace('/', '.');

	  case METHOD:
	    StringBuffer buf = new StringBuffer();
	    int i, j;

	    buf.append(id);
	    buf.appendChar('(');

	    for (i = 1 ; sig.charAt(i) != METHODEND ; i = j) {
		for (j = i ; sig.charAt(j) == ARRAY ; j++);
		if (sig.charAt(j++) == OBJECT) {
		    while (sig.charAt(j++) != OBJECTEND);
		}
		if (i > 1) {
		    buf.appendChar(',');
		}
		buf.append(TypeSignature.toString(sig.substring(i, j), "", abbrev, ret));
	    }
	    buf.appendChar(')');

	    s = buf.toString();
	    return ret ? TypeSignature.toString(sig.substring(i + 1), s, abbrev, false) : s;

	  default:
	    s = "<error>";
	    break;
	}

	return (id.length() > 0) ? s + " " + id : s;
    }
}

class ProfValue {
    int time;
    int count;
    String name;
    ProfValue next;

    ProfValue(String nm) {
	name = nm;
    }

    boolean greater(ProfValue v) {
	if (time > v.time) {
	    return true;
	}
	if (time < v.time) {
	    return false;
	}
	return count > v.count;
    }

    ProfValue sort(ProfValue v) {
	if (greater(v)) {
	    next = (next == null) ? v : next.sort(v);
	    return this;
	}
	v.next = this;
	return v;
    }

    String classNm() {
	String str = name.substring(0, name.indexOf('.'));
	return str.substring(str.lastIndexOf('/') + 1);
    }

    String className() {
	return name.substring(0, name.indexOf('.')).replace('/', '.');
    }
    
    String methodName() {
	int i = name.indexOf('.') + 1;
	int j = name.indexOf('(');
	return name.substring(i, j);
    }

    String typeSignature() {
	return name.substring(name.indexOf('('));
    }
}

class ProfTable extends Hashtable {
    ProfValue value(String key) {
	ProfValue v = (ProfValue)get(key);
	if (v == null) {
	    v = new ProfValue(key);
	    put(key, v);
	}
	return v;
    }
}

class Prof {
    public static void main(String argv[]) {
	boolean verbose = false;
	String file = "java.prof";
	for (int i = 0 ; i < argv.length ; i++) {
	    if (argv[i].equals("-v")) {
		verbose = true;
	    } else if (argv[i].startsWith("-")) {
		System.err.println("invalid argument: " + argv[i]);
		return;
	    } else {
		file = argv[i];
	    }
	}

	FileInputStream f = new FileInputStream(file);
	byte b[] = new byte[f.available()];
	f.read(b);
	f.close();

	int i, j;
	char c[] = new char[b.length];
	for (i = 0 ; i < b.length ; i++) {
	    c[i] = b[i];
	}

	// Read method header
	for (i = 0 ; c[i++] != '\n' ;);
	
	// Read method calls
	ProfTable meth = new ProfTable();
	for (; i < c.length ; i++) {
	    if (c[i] == '#') {
		break;
	    }
	    int count = 0;

	    for (; (c[i] != ' ') && (c[i] != '\n') ; i++) {
		count = (count * 10) + c[i] - '0';
	    }
	    if (c[i] == '\n') {
		continue;
	    }
	    for (j = ++i ; (c[j] != ' ') && (c[j] != '\n') ; j++);
	    String callee = new String(c, i, j - i);

	    if (c[j] == '\n') {
		continue;
	    }

	    for (i = ++j ; (c[j] != ' ') && (c[j] != '\n') ; j++);
	    String caller = new String(c, i, j - i);

	    if (c[j] == '\n')  {
		//if ((c[j] == '\n') || caller.equals("?.?")) {
		continue;
	    }

	    int time = 0;
	    for (i = ++j ; c[i] != '\n' ; i++) {
		time = (time * 10) + c[i] - '0';
	    }
	    if (c[i] != '\n') {
		continue;
	    }
	    // System.out.println("caller = " + caller + ", callee = " + callee + ", time = " + time + ", count = " + count);
	    if ((count >= 0) && (time >= 0) && (count < 100000000) && (time < 10000000)) {
		ProfValue calleeval = meth.value(callee);
		ProfValue callerval = meth.value(caller);

		calleeval.time += time;
		calleeval.count += count;
		callerval.time -= time;
	    }
	}
	
	// Read memory header
	while (c[i++] != '\n');

	int handlesUsed = 0;
	for (; (c[i] != ' ') && (c[i] != '\n') ; i++) {
	    handlesUsed = (handlesUsed * 10) + c[i] - '0';
	}
	while (c[i] == ' ') i++;

	int handlesFree = 0;
	for (; (c[i] != ' ') && (c[i] != '\n') ; i++) {
	    handlesFree = (handlesFree * 10) + c[i] - '0';
	}
	while (c[i] == ' ') i++;

	int heapUsed = 0;
	for (; (c[i] != ' ') && (c[i] != '\n') ; i++) {
	    heapUsed = (heapUsed * 10) + c[i] - '0';
	}
	while (c[i] == ' ') i++;

	int heapFree = 0;
	for (; (c[i] != ' ') && (c[i] != '\n') ; i++) {
	    heapFree = (heapFree * 10) + c[i] - '0';
	}
	while (c[i++] != '\n');

	// read instance memory header
	while (c[i++] != '\n');

	// read memory dump
	ProfTable mem = new ProfTable();
	while (i < c.length) {
	    for (j = i ; c[i] != ' ' ; i++);
	    String type = new String(c, j, i - j);
	    while (c[i] == ' ') i++;
	    
	    int count = 0;
	    for (; (c[i] != ' ') && (c[i] != '\n') ; i++) {
		count = (count * 10) + c[i] - '0';
	    }

	    while (c[i] == ' ') i++;
	    int bytes = 0;
	    for (; (c[i] != ' ') && (c[i] != '\n') ; i++) {
		bytes = (bytes * 10) + c[i] - '0';
	    }
	    while (c[i++] != '\n');
	    if ((count >= 0) && (bytes >= 0)) {
		ProfValue memval = mem.value(type);
		memval.count += count;
		memval.time += bytes;
		// System.out.println(type + ", " + count + ", " + bytes);
	    }
	}
	
	

	int totaltime = 0;
	int totalcount = 0;
	ProfTable clz = new ProfTable();
	ProfValue list = null;
	
	for (Enumeration e = meth.elements() ; e.hasMoreElements() ; ) {
	    ProfValue v = (ProfValue)e.nextElement();
	    if ((v.time > 0) || (v.count != 0)) {
		totaltime += v.time;
		totalcount += v.count;
	    }

	    try {
		String clznm = v.className();
		clz.value(clznm).time += v.time;
		clz.value(clznm).count += v.count;
	    } catch (StringIndexOutOfRangeException ee) {
	    }

	    list = (list != null) ? list.sort(v) : v;
	}

	System.out.println("total time = " + totaltime + "ms, number of calls = " + totalcount +
		" (" + ((totaltime * 1000) / totalcount) + " us/call, " +
	        (totalcount / totaltime) + "k calls/sec)");
	System.out.println("heap = " + ((heapUsed + heapFree) / 1024) + "k (" +
			   (heapUsed / 1024) + "k used), " +
			   (handlesFree + handlesUsed) + " handles (" + handlesUsed + " used)");
			   	

	System.out.println("");
	System.out.println("% of	total	number	average  method-name");
	System.out.println("total	ms	calls	us");
	System.out.println("---------------------------------------------");
	for (; list != null ; list = list.next) {
	    if ((list.time >= 0) && (list.count > 0)) {
		if ((!verbose) && (((list.time * 100.0) / totaltime) < 0.1)) {
		    break;
		}
		String percent = String.valueOf((list.time * 100.0) / totaltime);
		if (percent.length() > 4) {
		    percent = percent.substring(0, 4);
		}
		System.out.print(percent + "%\t" +
		      list.time + "\t" +
		      list.count + "\t" +
		      ((list.time * 1000)/ list.count) + "\t");
		
		System.out.print(list.classNm());
		String str = list.methodName();
		if (str.equals("<init>")) {
		    str = TypeSignature.toString(list.typeSignature(), "", true, false);
		} else {
		    str = "." + TypeSignature.toString(list.typeSignature(), str, true, false);
		}
		System.out.println(str);
	    }
	}

	list = null;
	for (Enumeration e = clz.elements() ; e.hasMoreElements() ; ) {
	    ProfValue v = (ProfValue)e.nextElement();
	    list = (list != null) ? list.sort(v) : v;
	}

	System.out.println("");
	System.out.println("% of	total	number	average	   class-name");
	System.out.println("total	ms	calls	us");
	System.out.println("---------------------------------------------");
	for (; list != null ; list = list.next) {
	    if ((list.time >= 0) && (list.count > 0)) {
		if ((!verbose) && (((list.time * 100.0) / totaltime) < 0.1)) {
		    break;
		}
		String percent = String.valueOf((list.time * 100.0) / totaltime);
		if (percent.length() > 4) {
		    percent = percent.substring(0, 4);
		}
		System.out.println(percent + "%\t" +
			list.time + "\t" +
			list.count + "\t" +
			((list.time * 1000)/ list.count) + "\t" +
			list.name.replace('/', '.'));
	    }
	}

	list = null;
	for (Enumeration e = mem.elements() ; e.hasMoreElements() ; ) {
	    ProfValue v = (ProfValue)e.nextElement();
	    list = (list != null) ? list.sort(v) : v;
	}

	System.out.println("");
	System.out.println("% of	total	number	average	   type-name");
	System.out.println("total	bytes	inst	bytes");
	System.out.println("---------------------------------------------");
	for (; list != null ; list = list.next) {
	    if ((!verbose) && (((list.time * 100.0) / heapUsed) < 0.01)) {
		break;
	    }
	    String percent = String.valueOf((list.time * 100.0) / heapUsed);
	    if (percent.length() > 4) {
		percent = percent.substring(0, 4);
	    }

	    System.out.println(percent + "\t" +
			       list.time + "\t" +
			       list.count + "\t" +
			     (list.time / list.count) + "\t" +
			     TypeSignature.toString(list.name, "", false, false));
	}
    }
}
