# @(#)library.mk	1.9 95/04/28

all : debug optimized

BUILDDIR=$(TOPDIR)/build/solaris

include $(TOPDIR)/build/solaris/makefiles/make.rules

LD = /usr/ccs/bin/ld
DEBUG = $(LIBRARY)_g.so
OPTIMIZED = $(LIBRARY).so

debug :: $(LIB)/$(DEBUG)

optimized :: $(LIB)/$(OPTIMIZED)

FILES.o  = $${FILES.c:%.c=obj$${VARIANT}/%.o} 
FILES.o += $${FILES.s:%.s=obj$${VARIANT}/%.o}

XFILES.o  = ${FILES.c:%.c=obj${VARIANT}/%.o} 
XFILES.o += ${FILES.s:%.s=obj${VARIANT}/%.o}

$(OPTIMIZED) : classheaders ${FILES.o} ${COREJAVALIBS}
	$(LD) -G -o $@ $(XFILES.o) $(OTHER_LIBS)

$(DEBUG)     : classheaders ${FILES.o} ${COREJAVALIBS} 
	$(LD) -G -o $@ $(XFILES.o) $(OTHER_LIBS)

DEFINES += -DDBINFO

$(DEBUG) := VARIANT = _g
$(DEBUG) := LDFLAGS += -g

install: $(LIB)/$(OPTIMIZED) $(LIB)/$(DEBUG)

$(LIB)/$(OPTIMIZED) $(LIB)/$(DEBUG) : $$(@D) $$(@F)
	 @-(ln -s `pwd`/$(@F) $(LIB)/ \
	 && echo "link to " $(LIB)/$(@F) "created.") 2>/dev/null

classheaders: $(CLASSES) $(FILES.class)
	for i in $(CLASSES_EXPORTED_TO_C) ;                      \
	do                                                       \
		$(JAVAH) -classpath $(CLASSES) -d CClassHeaders $$i ; \
	done

STUBPREAMBLE = $(SHARE_JAVA)/include/StubPreamble.h
CLASSES_EXPORTED_TO_C_2=echo ${CLASSES_EXPORTED_TO_C} | sed "s:\.:/:g"
CLASSES_EXPORTED_TO_C_3=${CLASSES_EXPORTED_TO_C_2:sh}
EXPORTED_CLASS_SRC=${CLASSES_EXPORTED_TO_C_3:%=${CLASSES}/%.class}

classes : $(FILES.class)

libstubs.c:  $(EXPORTED_CLASS_SRC)
	$(JAVAH) $(JAVAHFLAGS) -classpath $(CLASSES) -o $@ \
		-stubs $(CLASSES_EXPORTED_TO_C) $(OTHER_CLASSES_EXPORTED_TO_C)

clobber:: FORCE
	rm -f $(OPTIMIZED) $(DEBUG) $(LIB)/$(OPTIMIZED) $(LIB)/$(DEBUG) 
	rm -rf CClassHeaders libstubs.c
