#!/bin/ksh
# This file is used to build a makefile that builds
# the class source heirarchy.
#

if [ $# -ne 3 ]
then
	echo "Usage: $0 topdir pkggpath packages"
	exit 1;
fi


TOPDIR="$1"
PKGPATH="$2"
PACKAGES="$3"


(

echo "TOPDIR=${TOPDIR}"; 
echo 'include $(TOPDIR)/build/solaris/makefiles/make.defs'; 
echo "TARGETS = ${PACKAGES}"
echo "cmd.dirs= echo \$(TARGETS) | sed 's/[\/a-zA-Z0-9]*.java//g'"
echo 'TARGETS.tmp = $(cmd.dirs:sh)'
echo 'TARGETS.dirs = $(TARGETS.tmp:%=$(CLASSSRC)/%)'
echo 'TARGETS.dummy=${TARGETS:%=dummy.%}'; 
echo 'SRCTOP=../../..'
echo "PKGPATH=${PKGPATH}"
echo ''; 
echo 'all : $(TARGETS.dummy)'; 
echo ''; 
echo ''
for i in ${PACKAGES} ; 
do 
	case $i in
	*.java)     
	    echo "dummy.$i := CLASSES.java=$i"
	    echo 'dummy.'$i' := CLASSES.dst=${CLASSES.java:%=$(CLASSSRC)/'$i'}'
	    echo 'dummy.'$i' : $(CLASSSRC)/'`dirname $i`' $${CLASSES.dst}'
	    echo ""
	    DIRS="\$(CLASSSRC)/`dirname $i` ${DIRS}"
	    ;;

	*) 
	    echo "dummy.$i := cmd=ls \${PKGPATH:%=%/$i} 2>/dev/null | grep '\.java\$\$' || exit 0"
	    echo 'dummy.'$i' := CLASSES.java=$(cmd:sh)'
	    echo 'dummy.'$i' := CLASSES.dst=${CLASSES.java:%=$(CLASSSRC)/'$i'/%}'
	    pkgprnt="`echo $i | sed -e 's#[^/]\{1,\}/#../#g' -e 's#[^/]\{1,\}$#..#'`"
	    echo "dummy.$i := pkgprnt=${pkgprnt}"
	    echo 'dummy.'$i' : $(CLASSSRC)/'$i' $${CLASSES.dst}'
	    DIRS="\$(CLASSSRC)/$i ${DIRS}"
	    echo ""
	    ;;
	esac
done
echo "${DIRS} : "
echo '	test -d $@ || mkdir -p $@'
echo ""
for i in ${PKGPATH} ; 
do
        echo '$(CLASSSRC)/%.java : '$i'/%.java'
	echo '	rm -f $@; ln -s $(SRCTOP)/$(pkgprnt)${<D:$(TOPDIR)%=%}/${<F} $@'
	echo ''
done
) >class.mk

