/*
 * @(#)counter.h	1.7 95/01/31  
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

#ifndef _COUNTER_H_
#define _COUNTER_H_

/*
 * Differential Counters
 */
typedef struct {
    int inc;
    int dec;
} counter_t;

#define COUNTER_NULL 	    ((counter_t *) 0)

counter_t *counterInit(void *, int);

/*
 * These are intended for asynchronous users, who can't wait on a
 * lock, and intend to use software conventions to enforce serialized
 * access to the counters.
 */
void counterIncrement(counter_t *, unsigned int);
void counterDecrement(counter_t *, unsigned int);

#endif /* !_COUNTER_H_ */
