/*
 * @(#)exception.c	1.19 95/02/17  
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/*-
 *      Implementation of class Exception
 *
 *      former classruntime.c, Wed Jun 26 18:43:20 1991
 */

#include <stdio.h>
#include <signal.h>

#include <tree.h>
#include <javaString.h>

#include <monitor.h>
#include <threads.h>
#include <exceptions.h>

#include <java_lang_Exception.h>
#include <java_lang_Thread.h>

void
java_lang_Exception_printStackTrace(Hjava_lang_Exception *o){
    int         n;
    HString *hstr;
    char buf[128];
    prints(classname2string(classname(obj_classblock(o)), buf, sizeof(buf)));
    hstr = (HString *)obj_getslot((Handle *)o, java_lang_Exception_TRACE_BACK_SIZE);
    if (hstr) {
	prints(" ");
	javaStringPrint(hstr);
    }
    for (n = 0; n < java_lang_Exception_TRACE_BACK_SIZE; n++)
	if (obj_getslot((Handle *)o, n)) {
	    char        where[100];
	    pc2string((unsigned char *) obj_getslot((Handle *)o, n), 0,
		      where, where + sizeof where);
	    prints("\n\tat ");
	    prints(where);
	}
    prints("\n");
}

Classjava_lang_Exception *
_fillInStackTrace(Classjava_lang_Exception *obj, ExecEnv *ee) {
    ClassObject *tp;
    int         i;
    JavaFrame    *frame;

    tp = (ClassObject *)obj;

    for (i = 0, frame = ee->current_frame; 
	    i < java_lang_Exception_TRACE_BACK_SIZE && frame; 
	    frame = frame->prev) {
	if (frame->current_method) {
	    uobj_setslot(tp, i, (OBJECT) frame->lastpc);
	    i++;
	}
    }
    while (i < java_lang_Exception_TRACE_BACK_SIZE) {
	uobj_setslot(tp, i, 0);
	i++;
    }
    return obj;
}

/*
 * Fill in the current stack trace in this exception.  This is
 * usually called automatically when the exception is created but it
 * may also be called explicitly by the user.  This routine returns
 * `this' so you can write 'throw e.fillInStackTrace();'
 */
Hjava_lang_Exception *
java_lang_Exception_fillInStackTrace(Hjava_lang_Exception *obj) {
    ExecEnv *ee = (ExecEnv *)(THREAD(threadSelf())->eetop);

    _fillInStackTrace(unhand(obj), ee);
    return obj;
}

