/*
 * @(#)awt_Color.c	1.10 95/05/12 Sami Shaio
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

#include "awt_p.h"

void
awt_WServer_colorCreate(Hawt_WServer *ws, Hawt_Color *this)
{
    Classawt_Color	*c;
    struct ColorData	*cdata;

    if (this == 0) {
	SignalError(0, JAVAPKG "NullPointerException", 0);
	return;
    }

    c = unhand(this);

    cdata = PDATA(ColorData, this);

    if (cdata == 0) {
	cdata = (struct ColorData *)malloc(sizeof(struct ColorData));
	SET_PDATA(this, cdata);
	if (cdata) {
	    cdata->initialized = 0;
	}
    }
    if (cdata && cdata->initialized == 0) {
	cdata->initialized = 1;
	cdata->color = awtImage->ColorMatch(c->r, c->g, c->b);
    }
}

Pixel
awt_getColor(Hawt_WServer *ws, Hawt_Color *this)
{
    struct ColorData	*cdata;

    if (this && ws) {
	cdata = PDATA(ColorData, this);
	if (cdata && cdata->initialized) {
	    return cdata->color;
	} else {
	    awt_WServer_colorCreate(ws, this);
	    cdata = PDATA(ColorData, this);
	    if (cdata && cdata->initialized) {
		return cdata->color;
	    } else {
		printf("awt_getColor failed\n");
		return 0;
	    }
	}
    } else {
	printf("awt_getColor failed\n");
	return 0;
    }
}
