/*
 * @(#)awt_MenuBar.c	1.17 95/01/31 Sami Shaio
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */
#include "awt_p.h"


void
awt_WServer_menuBarCreate(Hawt_WServer *ws,
			  Hawt_MenuBar *this,
			  Hawt_Frame *frame)
{
    Arg			args[20];
    int			argc;
    Classawt_Frame	*framePtr;
    struct MenuBarData	*mdata; 
    struct FrameData	*wdata;
    Pixel		bg;

    if (frame == 0) {
	SignalError(0, JAVAPKG "NullPointerException", 0);
	return;
    }
    framePtr = unhand(frame);
    wdata = PDATA(FrameData,frame);
    mdata = (struct MenuBarData *)malloc(sizeof(struct MenuBarData));
    SET_PDATA(this, mdata);

    XtVaGetValues(wdata->winData.w,
		  XmNbackground, &bg,
		  NULL);

    argc=0;
    XtSetArg(args[argc], XmNbackground, bg); argc++;
    XtSetArg(args[argc], XmNresizeWidth, False); argc++;
    mdata->menuBar = XmCreateMenuBar(wdata->mainW, "menu_bar", args, argc);
    XmMainWindowSetAreas(wdata->mainW,
			 mdata->menuBar,
			 NULL,
			 NULL,
			 NULL,
			 wdata->winData.w);
    wdata->menuBar = mdata->menuBar;
    XtManageChild(mdata->menuBar);
    
}


void
awt_WServer_menuBarDispose(Hawt_WServer *ws,
			   Hawt_MenuBar *this)
{
    struct MenuBarData *mdata = PDATA(MenuBarData,this);
    XtDestroyWidget(mdata->menuBar);
    free((void *)mdata);
}
    

void
awt_WServer_menuBarAddMenu(Hawt_WServer *ws,
			   Hawt_MenuBar *this,
			   Hawt_Menu *m)
{
}

void
awt_WServer_menuBarDelMenu(Hawt_WServer *ws,
			   Hawt_MenuBar *this,
			   Hawt_Menu *m)
{
}
