/*
 * @(#)color.h	1.8 95/03/09 Sami Shaio
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */
#ifndef _COLOR_H_
#define _COLOR_H_

typedef struct {
    int Depth;
    int awtBitsPerPixel;
    int rOff;
    int gOff;
    int bOff;
    XVisualInfo wsVisualInfo;
    XPixmapFormatValues wsImageFormat;
    int (*ColorMatch)(int, int, int);
    void (*Ditherfrom8)(u_char *, u_char *, u_char *,
			u_char *, int, u_long *, int,
			int, int, int);
    void (*DitherScalefrom8)(u_char *, u_char *, u_char *,
			     u_char *, int, int, int,
			     u_long *, u_char *, int,
			     int, int, int);
    int (*RetrieveColors)(u_char *, u_char *, u_char *);
} awtImageData;

extern awtImageData *awtImage;

/*
 * Find the best color
 */
extern int awt_color_match(int r, int g, int b);


extern int awt_allocate_colors(Display *dpy);


/* Dithering algorithms
 */
extern void awt_dither_image0(u_char *rm, u_char *gm, u_char *bm,
			      u_char *p1, int off1,
			      u_long *p2, int off2, int w, int h, int trans_index);


extern void awt_dither_image1(u_char *rm, u_char *gm, u_char *bm,
			      u_char *p1, int off1,
			      u_long *p2, int off2, int w, int hm, int trans_index);


extern void awt_dither_image2(u_char *rm, u_char *gm, u_char *bm,
			      u_char *p1, int off1,
			      u_long *p2, int off2, int w, int h, int trans_index);

extern void awt_dither_scale_image(u_char *rm, u_char *gm, u_char *bm,
				   u_char *p1, int off1, int sw, int sh,
				   u_long *p2, u_char *t2, int off2,
				   int dw, int dh,
				   int trans_index);

/*
 * Color retrieval access function.
 */
extern int awt_retrieve_colors(u_char *rm, u_char *gm, u_char *bm);

#endif           /* _COLOR_H_ */
