/*
 * @(#)internal_md.h	1.5 95/01/31  
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/*
 * Solaris-specific components of Green threads
 */

#ifndef _SOLARIS_INTERNAL_MD_H_
#define _SOLARIS_INTERNAL_MD_H_

#include <signal.h>

/*
 * Machine dependent info
 */
typedef struct {
    int needReschedule;
    sigset_t intrLockOldMask;
    int intrLockCount;
} machdep_t;

#define MACHDEP(tid)    (&((tid)->machdep))

/*
 * SPARC requires that all stacks be doubly-aligned (8 byte boundary).
 */
typedef double  *stackp_t;


#endif /* !_SOLARIS_INTERNAL_MD_H_ */
