/*
 * @(#)queue.h	1.5 95/01/31  
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/*
 * A set of queue handling macros for processes.  Generic to Green
 * threads package.
 */

#ifndef _GREEN_QUEUE_H_
#define _GREEN_QUEUE_H_

#include <monitor_md.h>
#include <threads_md.h>

typedef sys_thread_t * queue_t;	/* linked through "waitq" field */

extern queue_t runnable_queue;

void queueInsert(queue_t *, sys_thread_t *);
int queueRemove(queue_t *, sys_thread_t *);
int queueSignal(sys_mon_t *, queue_t *);
void queueWait(sys_mon_t *, queue_t *);
void queueBroadcast(sys_mon_t *);
#define queueRemoveHead(q, t) (t=*(q), (t ? *(q)=(t)->waitq : 0), t)

#endif /* !_GREEN_QUEUE_H_ */
