/*
! @(#)double_md.s 1.2 95/05/01 Copyright 1994 Sun Microsystems
!	Frank Yellin
*/

/* Some compilers assume that all 64-bit quantities are 64-bit aligned.  The
 * JAVA spec only requires that they be 32-bit aligned.
 *
 * On those compiles that have 64-bit-alignment, loads and stores of 64-bit
 * quantities should be turned into calls to GET_INT64, GET_DOUBLE,
 * SET_INT64, and SET-DOUBLE.  
 *
 * These functions before the loads and stores, but only assume 32-bit
 * alignment.
 */ 
    	.global GET_INT64
    	.global GET_DOUBLE
    	.global SET_INT64
    	.global SET_DOUBLE

!! int64_t GET_INT64(void *address) { 
!!      return *(int64_t *)address; 
!! }

GET_INT64: 
	ld	[%o0 + 4], %o1 
	retl
	ld	[%o0+4], %o0

!! double GET_DOUBLE(void *address) { 
!!    return *(double *)address; 
!! } 

GET_DOUBLE: 
	ld	[%o0], %f0
	retl
	ld	[%o0+4], %f1

!! void SET_INT64(void *address, int64_t value) { 
!!     *(int64_t *)address = value; 
!! }
!!
!! void SET_DOUBLE(void *address, double value) { 
!!     *(double *)address = value; 
!! }

SET_DOUBLE: 
SET_INT64:   
    	st  	%o1, [%o0]
    	retl
    	st  	%o2, [%o0 + 4]






