/*
 * @(#)path_md.c	1.10 95/01/31  
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/*
 * Machine dependent path name and file name manipulation code
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "path_md.h"
#include "installpath.h"

int
sysGetFileSeparator()
{
    return('/');
}


char **
CLASSPATH() {
    static char **classpath;
    if (classpath == 0) {
        char *st, *p;
        char *cpv;
        char **cpa;
        int npa = 3;
        if ((cpv = getenv("CLASSPATH")) == 0) {
            cpv = ":classes:" INSTALLPATH "/classes";
	}
        cpv = strdup(cpv);
        for (st = cpv; *st; st++) {
            if (*st == ':') {
                npa++;
	    }
	}
        classpath = (char **) malloc(npa * sizeof(char *));
        cpa = classpath;
        st = cpv;
        for (p = st; *p; p++) {
            if (*p == ':') {
                if (p != st) {
                    *cpa++ = st;
		}
                *p++ = 0;
                st = p;
            }
	}
        if (p != st) {
            *cpa++ = st;
	}
        *p++ = 0;
        *cpa++ = 0;
    }
    return classpath;
}    
 
