/*
 * @(#)seenfile_md.c	1.5 95/01/31  
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/*
 * Machine Dependent class importing code
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>

#include "oobj.h"
#include "interpreter.h"
#include "path_md.h"
#include "installpath.h"

long SeenFile_md(char *, long);

long
SeenFile_md(char *fn, long state) {
    struct LoadedFile {
        dev_t       dev;
        ino_t       ino;
        long state;
        struct LoadedFile *nxt;
    };
    static struct LoadedFile *LoadedFiles;
    static int  nloaded, sizeloaded;
    struct LoadedFile *scan;
    struct stat st;

    if (stat(fn, &st) < 0) {
        return (-1);
    }

    if (state == sfs_forget_everything) {
        nloaded = 0;
        return state;
    }
    if (LoadedFiles) {
        for (scan = LoadedFiles; scan->nxt != NULL; scan = scan->nxt) {
            if (scan->ino == st.st_ino && scan->dev == st.st_dev) {
                long ret = scan->state;
                if (state > scan->state) {
                    scan->state = state;
		}
                return ret;
            }
	}
    }
    scan = (struct LoadedFile *)calloc(1, sizeof(struct LoadedFile));
    if (LoadedFiles) {
     	scan->nxt = LoadedFiles;
    }
    LoadedFiles = scan;
    if (LoadedFiles == 0) {
        out_of_memory();
    }
    nloaded++;
    scan->dev = st.st_dev;
    scan->ino = st.st_ino;
    scan->state = state;
    return sfs_query;
}
 
