/*
 * @(#)system_md.c	1.10 95/05/10  
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

#include <stdlib.h>
#include <unistd.h>
#include <timeval.h>
#include <sys/time.h>

#include <sys_api.h>

/* Not in sys/time.h, for some reason */
int gettimeofday(struct timeval *tp, struct timezone *tzp);
int gethostid(void);

long
sysGetMilliTicks()
{
    struct timeval tv;

    (void) gettimeofday(&tv, (struct timezone *) 0);
    return((tv.tv_sec * 1000) + (tv.tv_usec / 1000));
}

long
sysTime(long *l_p)
{
    return(time(l_p));
}

int64_t
sysTimeMillis()
{
    struct timeval t;
    gettimeofday(&t, 0);
    return ll_add(ll_mul(int2ll(t.tv_sec), int2ll(1000)), int2ll(t.tv_usec/1000));
}

/* Moved here as a portability concern - not availiable on all platforms */

void ll2str(int64_t number, char *s, char *limit)
{
#define MAGIC    10000000	/* slightly more than (2^64) ^ (1/3) */
    int group1, group2, group3;
    char *sign;

    if (number >= 0) {
		sign = "";
        number = -number;	/* this lets -2^63 still work! */
    } else {
		sign = "-";
    }

    group3 = -(number % MAGIC);	/* low 7 digits */
    number = (number + group3)/MAGIC;
    group2 = -(number % MAGIC);	/* next 7 digits */
    number = (number + group2)/MAGIC;
    group1 = -number;		/* high 7 digits */
    if (group1 != 0) 
        sprintf(s, "%s%d%07.7d%07.7d", sign, group1, group2, group3);
    else if (group2 != 0) 
        sprintf(s, "%s%d%07.7d", sign, group2, group3);
    else 
        sprintf(s, "%s%d", sign, group3);      
}


